package com.gxzc.zen.common.util

import com.gxzc.zen.common.contants.PLATFORM
import com.gxzc.zen.common.properties.PlatformProperties
import org.slf4j.LoggerFactory

/**
 * 平台工具类
 * @author NorthLan
 * @date 2018/2/6
 * @url https://noahlan.com
 */
object PlatformUtil {
    private val logger = LoggerFactory.getLogger(PlatformUtil::class.java)

    var properties: PlatformProperties? = null
        get() {
            if (field == null) {
                field = SpringContextHolder.getBean(PlatformProperties::class.java)
            }
            return field
        }

    fun getPlatformId(): Int {
        return try {
            properties!!.id!!
        } catch (e: Throwable) {
            logger.warn("error get platform properties, cause", e)
            0
        }
    }

    fun getPlatform(id: Int): PLATFORM {
        return PLATFORM.intValueOf(id)
    }

    fun getPlatform(): PLATFORM {
        return getPlatform(getPlatformId())
    }

    fun getPlatform(properties: PlatformProperties): PLATFORM {
        return getPlatform(properties.id!!)
    }
}